package project;

import java.util.ArrayList;
import java.util.Date;

public class Auction {

	static int idCounter;
	public static ArrayList<Auction> auctions = new ArrayList<Auction>();

	private ArrayList<User> subscribedUsers = new ArrayList<User>();
	private ArrayList<Bid> bids = new ArrayList<Bid>();
	private int id;
	private Item item;
	private Date start, end;
	private double price, bidIncrement;
	private User currentLeader;

	public Auction(Item item, Date start, Date end, double price, double bidIncrement) {

		subscribedUsers = new ArrayList<User>();
		id = idCounter++;
		this.item = item;
		this.start = start;
		this.end = end;
		this.price = price;
		this.bidIncrement = bidIncrement;
		auctions.add(this);

	}

	public Auction() {

		subscribedUsers = new ArrayList<User>();
		id = idCounter++;
		auctions.add(this);

	}

	public static Auction getInstance() {

		return new Auction();

	}

	public boolean subscribe(int id) {

		for (User u : User.users) {

			if (u.getId() == id) {

				subscribedUsers.add(u);
				return true;

			}

		}

		return false;

	}

	public boolean assignToUser(int itemId, int userId) {

		for (Item i : Item.items) {

			if (i.getId() == itemId) {

				for (User u : User.users) {

					if (u.getId() == userId) {

						u.addItemToList(itemId);
						return true;

					}

				}

			}

		}

		return false;

	}

	public String getTitle() {

		return item.getTitle();
	}

	public Category getCategory() {

		return item.getCategory();
	}

	public Date getEnd() {

		return end;

	}

	public Date getStart() {

		return start;

	}

	public double getPrice() {

		return price;

	}

	public void setCurrentLeader(User u) {

		this.currentLeader = u;

	}

	public void setPrice(double d) {

		this.price = d;

	}

	public void setEnd(Date endDate) {

		this.end = endDate;

	}

	public ArrayList<Bid> getBids() {

		return bids;

	}

	public void setBids(ArrayList<Bid> bids) {

		this.bids = bids;

	}

}
