package project;

import java.util.ArrayList;

import exceptions.CategoryInvalidException;
import exceptions.LoginInvalidException;
import exceptions.EmailInvalidException;
import exceptions.PasswordInvalidException;
import exceptions.PriceInvalidException;
import exceptions.TitleInvalidException;
import exceptions.UsernameEmailEmptyException;

public class User {

	static int idCounter;
	public static ArrayList<User> users = new ArrayList<User>();
	private ArrayList<Item> myItems;
	private int id;
	private String username, email, password;

	public User() {

		username = "";
		email = "";
		password = "";

		myItems = new ArrayList<Item>();
		
		this.id = idCounter++;
		users.add(this);

	}

	public User(int id) {

		username = "";
		email = "";
		password = "";

		myItems = new ArrayList<Item>();
		
		this.id = id;
		users.add(this);

	}

	public User(String usernameInput, String mailInput, String passwordInput) {

		username = usernameInput;
		email = mailInput;
		password = passwordInput;

		this.id = idCounter++;
		users.add(this);

	}

	public static User getInstance() {

		return new User();
		

	}

	public static boolean login(String username, String email, String password)
			throws UsernameEmailEmptyException, PasswordInvalidException, EmailInvalidException, LoginInvalidException {

		if (username.equals("") && email.equals("")) {

			throw new UsernameEmailEmptyException();

		} else {

			if (password.equals("")) {

				throw new PasswordInvalidException();

			} else if (!username.equals("")) {

				User toCheck = null;

				for (User u : users) {

					if (u.username.equals(username)) {

						toCheck = u;

					}

				}

				if (toCheck == null) {

					throw new LoginInvalidException();

				} else {

					if (password.equals(toCheck.password)) {

						return true;

					} else {

						throw new LoginInvalidException();

					}

				}

			} else if (!email.matches("\\S+@\\S+\\.\\S+")) {

				throw new EmailInvalidException();

			} else {

				User toCheck = null;

				for (User u : users) {

					if (u.email.equals(email)) {

						toCheck = u;

					}

				}

				if (toCheck == null) {

					throw new LoginInvalidException();

				} else {

					if (password.equals(toCheck.password)) {

						return true;

					} else {

						throw new LoginInvalidException();

					}

				}

			}

		}

	}

	public ArrayList<Auction> retrieveSubscribedAuction() {

		return null;

	}

	public ArrayList<Item> searchItem(String title, String category)
			throws CategoryInvalidException, TitleInvalidException {

		if (!title.matches("^[a-zA-Z\\s]+$") || title.length() > 30 || title.length() < 1) {

			throw new TitleInvalidException();

		} else {

			Category c = Category.getCategory(category);

			if (c == null) {

				throw new CategoryInvalidException();

			} else {

				ArrayList<Item> toReturn = new ArrayList<Item>();

				for (Item i : Item.items) {

					if (i.getTitle().equals(title) && i.getCategory().equals(c)) {

						toReturn.add(i);

					}

				}

				return toReturn;
			}

		}
	}

	public ArrayList<Auction> searchAuction(double price, String title, String category)
			throws CategoryInvalidException, TitleInvalidException, PriceInvalidException {

		if (!title.matches("^[a-zA-Z\\s]+$") || title.length() > 30 || title.length() < 1) {

			throw new TitleInvalidException();

		} else {

			Category c = Category.getCategory(category);

			if (c == null) {

				throw new CategoryInvalidException();

			} else if (price <= 0) {

				throw new PriceInvalidException();

			} else {

				ArrayList<Auction> toReturn = new ArrayList<Auction>();

				for (Auction a : Auction.auctions) {

					if (a.getTitle().equals(title) && a.getCategory().equals(c)
							&& (price > a.getPrice() || a.getPrice() - price <= 0)) {

						toReturn.add(a);

					}

				}

				return toReturn;

			}

		}

	}

	public boolean addItemToList(int itemId) {

		if (!myItems.contains(Item.getItem(itemId))) {

			myItems.add(Item.getItem(itemId));
			return true;

		}

		return false;

	}

	public void setId(int i) {

		this.id = i;

	}

	public int getId() {

		return id;

	}

	public void setUsername(String usernameInput) {

		this.username = usernameInput;
	}

	public void setEmail(String emailInput) {

		this.email = emailInput;

	}

	public void setPassword(String passwordInput) {

		this.password = passwordInput;
	}

	public static User getUserById(int user) {

		for (User u : users) {

			if (u.getId() == user) {

				return u;

			}

		}

		return null;

	}

}
